# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}

%define section free
%define oname velocity-tools

Name:           velocity-tools2
Version:        2.0
Release:        1%{?dist}
Epoch:          0
Summary:        Velocity application building tools
License:        Apache Software License
URL:            http://velocity.apache.org/tools/releases/2.0/
Group:          Development/Libraries/Java
Source0:        http://www.apache.org/dist/velocity/tools/2.0/velocity-tools-2.0-src.tar.gz
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        sslext-1.2-0.jar
Patch0:         %{name}-pom.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  httpunit
BuildRequires:  jetty6-embedded
BuildRequires:  junit431
BuildRequires:  nekohtml
BuildRequires:  rhino
BuildRequires:  apache-commons-beanutils
BuildRequires:  apache-commons-chain
BuildRequires:  apache-commons-collections
BuildRequires:  apache-commons-digester
BuildRequires:  apache-commons-lang
BuildRequires:  apache-commons-logging
BuildRequires:  apache-commons-validator
BuildRequires:  dom4j
BuildRequires:  jaxen >= 0:1.1
BuildRequires:  servlet_2_5_api
BuildRequires:  struts >= 0:1.3.8
BuildRequires:  struts-taglib >= 0:1.3.8
BuildRequires:  struts-tiles >= 0:1.3.8
# FIXME
#BuildRequires:  struts-sslext >= 0:1.2
BuildRequires:  velocity >= 0:1.6.2
BuildRequires:  oro >= 0:2.0.8
%if %{with_maven}
BuildRequires:  maven2 >= 2.0.8
BuildRequires:  maven2-plugin-changelog
BuildRequires:  maven2-plugin-changes
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-project-info-reports
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  mojo-maven2-plugin-taglist
BuildRequires:  maven2-default-skin
BuildRequires:  subversion
BuildRequires:  xmlrpc
%endif

Requires:  java >= 0:1.6.0
Requires:  apache-commons-beanutils
Requires:  apache-commons-chains
Requires:  apache-commons-collections
Requires:  apache-commons-digester
Requires:  apache-commons-lang
Requires:  apache-commons-logging
Requires:  apache-commons-validator
Requires:  dom4j
Requires:  jaxen >= 0:1.1
Requires:  struts >= 0:1.3.8
Requires:  struts-taglib >= 0:1.3.8
Requires:  struts-tiles >= 0:1.3.8
Requires:  velocity
Requires:  oro
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
%if %{gcj_support}
BuildRequires:    java-gcj-compat-devel
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%description
VelocityTools is a collection of Velocity subprojects with a common
goal of creating tools and infrastructure for building both web and
non-web applications using the Velocity template engine.

%package        manual
Summary:        Manual for %{name}
Group:          Development/Libraries/Java

%description    manual
Documentation for %{name}.

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
Javadoc for %{name}.

%package        demo
Summary:        Demo for %{name}
Group:          Development/Libraries/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description    demo
Demonstrations and samples for %{name}.

%prep
%setup -q -n %{oname}-%{version}-src
# Remove all binary libs used in compiling the package.
#FIXME Use struts-sslext package
find lib -name "*.jar" -and -not -name sslext-1.2.jar -print | xargs rm -f
cp %{SOURCE1} settings.xml
mkdir -p src/site
rm xdocs/config.xml.xml
%patch0 -b .orig


%if %{with_maven}
mkdir -p .m2/repository/JPP/
cp %{SOURCE3} .m2/repository/JPP/sslext.jar
%else

mkdir -p lib
(cd lib
cp %{SOURCE3} .
ln -sf $(build-classpath commons-beanutils)
ln -sf $(build-classpath commons-collections)
ln -sf $(build-classpath commons-digester)
ln -sf $(build-classpath commons-lang)
ln -sf $(build-classpath commons-logging)
ln -sf $(build-classpath commons-validator)
ln -sf $(build-classpath dom4j)
ln -sf $(build-classpath jaxen)
ln -sf $(build-classpath oro)
ln -sf $(build-classpath servlet_2_3_api)
ln -sf $(build-classpath struts)
ln -sf $(build-classpath struts-taglib)
ln -sf $(build-classpath struts-tiles)
ln -sf $(build-classpath velocity)
ln -sf $(build-classpath velocity-dvsl)
)
%endif

%build
%if %{with_maven}
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        -Dtest.conf.dir=$(pwd)/test/conf \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        install javadoc:javadoc site
%else
ant -Dskip.jar.loading=true jar.struts jar.view jar.generic javadoc docs
%endif

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 dist/%{oname}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%if ! %{with_maven}
install -m 644 dist/%{oname}-generic-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-generic-%{version}.jar
install -m 644 dist/%{oname}-view-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-view-%{version}.jar
%endif
%add_to_maven_depmap %{name} %{name} %{version} JPP %{name}
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 pom.xml.orig \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%if %{with_maven}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%else
cp -pr docs/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
rm -rf docs/javadoc
%endif
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/site
cp LICENSE README.txt WHY_THREE_JARS.txt STATUS \
                  $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
%if %{with_maven}
cp -pr target/site/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/site
%else
cp -pr docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/site
%endif

# demo
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
cp -pr examples test $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENSE
%doc %{_docdir}/%{name}-%{version}/STATUS
%doc %{_docdir}/%{name}-%{version}/*.txt
%{_javadir}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/site

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%files demo
%defattr(0644,root,root,0755)
%{_datadir}/%{name}-%{version}

%changelog
* Sun Dec 26 2010 Ralph Apel <r.apel at r-apel.de> 0:2.0-1
- First release as velocity-tools2

* Sat Dec 25 2010 Ralph Apel <r.apel at r-apel.de> 0:1.4-2
- First JPP-6 release

* Wed Mar 18 2009 Ralph Apel <r.apel at r-apel.de> 0:1.4-1.jpp5
- Upgrade to 1.4
- First JPP-5 release

* Mon Aug 27 2007 Ralph Apel <r.apel at r-apel.de> 0:1.3-1jpp
- Upgrade to 1.3
- Build with maven2 by default
- Make Vendor, Distribution based on macro
- Add pom and depmap frags
- Add gcj_support option

* Sat Mar 11 2006 Fernando Nasser <fnasser@redhat.com> 0:1.2-1jpp
- Upgrade to 1.2

* Fri Mar 10 2006 Fernando Nasser <fnasser@redhat.com> 0:1.1-5jpp
- First JPP 1.7 build

* Wed Aug 17 2005 Ralph Apel <r.apel at r-apel.de> 0:1.1-4jpp
- Fix build-classpath arguments
- Change struts requirement to struts11

* Mon Sep 13 2004 Ralph Apel <r.apel at r-apel.de> 0:1.1-3jpp
- Drop saxpath requirement
- Require jaxen >= 0:1.1
- Add missing runtime requires

* Thu Sep 02 2004 Ralph Apel <r.apel at r-apel.de> 0:1.1-2jpp
- Build with ant-1.6.2
- Relax some versioned dependencies

* Sun Jun 27 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:1.1-1jpp
- First JPP build

